'From Smalltalk/X, Version:5.2.8 on 31-12-2007 at 13:14:33'                     !

"{ Package: 'SpreadSheet:simekf1' }"

TestCase subclass:#OperatorTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'obp-SpreadSheet'
!

!OperatorTests methodsFor:'testing'!

testCellReference
        | i d f i2 s sheet|
        sheet:= SpreadSheet new.
        sheet cellAtRow: 1 column: 1 put: 3.
        sheet cellAtRow: 1 column: 2 put: (Date fromDays: 365).
        sheet cellAtRow: 1 column: 3 put: 2.75.
        sheet cellAtRow: 2 column: 1 put: 4.
        sheet cellAtRow: 2 column: 2 put: 'foobar'.


        i := CellReference newAtRow: 1 column: 1 atSheet: sheet.
        d := CellReference newAtRow: 1 column: 2 atSheet: sheet.
        f := CellReference newAtRow: 1 column: 3 atSheet: sheet.
        i2 := CellReference newAtRow: 2 column: 1 atSheet: sheet.
        s := CellReference newAtRow: 2 column: 2 atSheet: sheet.

        self assert: ((i operatorPlus: d) isNil).
        self assert: ((i operatorPlus: f) = 5.75).
        self assert: ((i operatorPlus: i2) = 7).
        self assert: ((i operatorPlus: s) isNil).
        self assert: ((i operatorMinus: d) isNil).
        self assert: ((i operatorMinus: f) = 0.25).
        self assert: ((i operatorMinus: i2) = -1).
        self assert: ((i operatorMinus: s) isNil).
        self assert: ((i operatorTimes: d) isNil).
        self assert: ((i operatorTimes: f) = 8.25).
        self assert: ((i operatorTimes: i2) = 12).
        self assert: ((i operatorTimes: s) isNil).
        self assert: ((i operatorOver: d) isNil).
        self assert: ((i operatorOver: 1.5) = 2.0).
        self assert: ((8 operatorOver: 4) = 2).
        self assert: ((i operatorOver: s) isNil).
        self assert: ((i operatorNegate) = -3).
!

testDate
        | d d2 f i s |

        d := Date fromDays: 5.
        d2 := Date fromDays: 365.
        f := 2.75.
        i := 4.
        s := 'foobar'.

        self assert: ((d operatorPlus: d2) isNil).
        self assert: ((d operatorPlus: f) isNil).
        self assert: ((d operatorPlus: i) = (Date fromDays: 9)).
        self assert: ((d operatorPlus: s) isNil).
        self assert: ((d2 operatorMinus: d) = 360).
        self assert: ((d operatorMinus: f) isNil).
        self assert: ((d operatorMinus: i) isNil).
        self assert: ((d operatorMinus: s) isNil).
        self assert: ((d operatorTimes: d2) isNil).
        self assert: ((d operatorTimes: f) isNil).
        self assert: ((d operatorTimes: i) isNil).
        self assert: ((d operatorTimes: s) isNil).
        self assert: ((d operatorOver: d2) isNil).
        self assert: ((d operatorOver: f) isNil).
        self assert: ((d operatorOver: i) isNil).
        self assert: ((d operatorOver: s) isNil).
        self assert: ((d operatorNegate) isNil).
!

testFloat
        | f d f2 i s |

        f := 3.0.
        d := Date fromDays: 365.
        f2 := 2.75.
        i := 4.
        s := 'foobar'.

        self assert: ((f operatorPlus: d) isNil).
        self assert: ((f operatorPlus: f2) = 5.75).
        self assert: ((3.5 operatorPlus: i) = 7.5).
        self assert: ((f operatorPlus: s) isNil).
        self assert: ((f operatorMinus: d) isNil).
        self assert: ((f operatorMinus: f2) = 0.25).
        self assert: ((2.5 operatorMinus: i) = -1.5).
        self assert: ((f operatorMinus: s) isNil).
        self assert: ((f operatorTimes: d) isNil).
        self assert: ((f operatorTimes: f2) = 8.25).
        self assert: ((3.75 operatorTimes: 2) = 7.5).
        self assert: ((f operatorTimes: s) isNil).
        self assert: ((f operatorOver: d) isNil).
        self assert: ((7.5 operatorOver: 4.0) = 1.875).
        self assert: ((f operatorOver: 6) = 0.5).
        self assert: ((f operatorOver: s) isNil).
        self assert: ((f operatorNegate) = -3.0).
!

testSmallInteger
        | i d f i2 s |

        i := 3.
        d := Date fromDays: 365.
        f := 2.75.
        i2 := 4.
        s := 'foobar'.

        self assert: ((i operatorPlus: d) isNil).
        self assert: ((i operatorPlus: f) = 5.75).
        self assert: ((i operatorPlus: i2) = 7).
        self assert: ((i operatorPlus: s) isNil).
        self assert: ((i operatorMinus: d) isNil).
        self assert: ((i operatorMinus: f) = 0.25).
        self assert: ((i operatorMinus: i2) = -1).
        self assert: ((i operatorMinus: s) isNil).
        self assert: ((i operatorTimes: d) isNil).
        self assert: ((i operatorTimes: f) = 8.25).
        self assert: ((i operatorTimes: i2) = 12).
        self assert: ((i operatorTimes: s) isNil).
        self assert: ((i operatorOver: d) isNil).
        self assert: ((i operatorOver: 1.5) = 2.0).
        self assert: ((8 operatorOver: 4) = 2).
        self assert: ((i operatorOver: s) isNil).
        self assert: ((i operatorNegate) = -3).
!

testString
        | s d f i s2 |

        s := 'test'.
        d := Date fromDays: 365.
        f := 2.75.
        i := 4.
        s2 := 'foobar'.

        self assert: ((s operatorPlus: d) = 'test1902-1-1').
        self assert: ((s operatorPlus: f) = 'test2.75').
        self assert: ((s operatorPlus: i) = 'test4').
        self assert: ((s operatorPlus: s2) = 'testfoobar').
        self assert: ((s operatorMinus: d) isNil).
        self assert: ((s operatorMinus: f) isNil).
        self assert: ((s operatorMinus: i) isNil).
        self assert: ((s operatorMinus: s2) isNil).
        self assert: ((s operatorTimes: d) isNil).
        self assert: ((s operatorTimes: f) isNil).
        self assert: ((s operatorTimes: i) = 'testtesttesttest').
        self assert: ((s operatorTimes: s2) isNil).
        self assert: ((s operatorOver: d) isNil).
        self assert: ((s operatorOver: f) isNil).
        self assert: ((s operatorOver: i) isNil).
        self assert: ((s operatorOver: s2) isNil).
        self assert: ((s operatorNegate) isNil).
! !

